//
//  file2.cpp
//  This C++ program demonstrates how to declare and use both
//  input and output files. The example program 
//  takes the order_price from customer.dat and generates
//  a billing_price that is printed to billing.dat.
//  Copyright (c) Chris H. Pappas and William H. Murray, 1998
//

#include <fstream.h>
#include <iomanip.h>
#define MIN_DISCOUNT .97
#define MAX_DISCOUNT .95

int main( )
{
  float forder_price, fbilling_price;
  ifstream fin("a:\\customer.dat");
  ofstream fout("a:\\billing.dat");

  fin >> forder_price;
  while (!fin.eof( )) {
    fout << setiosflags(ios::fixed);
    fout << "Your order of \t\t$" << setprecision(2) \
         << setw(8) << forder_price << "\n";
    if (forder_price < 10000)
       fbilling_price = forder_price * MIN_DISCOUNT;
    else fbilling_price = forder_price * MAX_DISCOUNT;
    fout << "is discounted to \t$" << setprecision(2) \
         << setw(8) << fbilling_price << ".\n\n";
    fin >> forder_price;
  }

  fin.close( );
  fout.close( );

  return(0);
}
