/*
*   fargv.c
*   C program illustrates how to read float data types
*   into the program with a command-line argument.
*   Copyright (c) Chris H. Pappas and William H. Murray, 1998
*/

#include <stdio.h>
#include <math.h>
#include <process.h>

const double dPi=3.14159265359;

int main(int argc, char *argv[])
{
  int t;
  double ddegree;

  if(argc<2) {
    printf("Type several angles on the command line.\n");
    printf("Program will calculate and print\n");
    printf("the cosine of the angles entered.\n");
    exit(1);
  }

  for (t=1; t<argc; t++) {
    ddegree=(double) atof(argv[t]);
    printf("The cosine of %f is %15.14lf\n",
           ddegree,cos((dPi/180.0)*ddegree));
  }

  return (0);
}

