/*
*   setvbuf.c
*   A C program demonstrating how to use setvbuf()
*   Copyright (c) William H. Murray and Chris H. Pappas, 1998
*/

#include <stdio.h>
#define MYBUFSIZ 512

void main(void)
{
   char ichar, cmybuffer[MYBUFSIZ];
   FILE *pfinfile, *pfoutfile;

   pfinfile = fopen("sample.in", "r");
   pfoutfile = fopen("sample.out", "w");

   if (setvbuf(pfinfile, cmybuffer, _IOFBF, MYBUFSIZ) != 0)
      printf("pfinfile buffer allocation error\n");
   else
      printf("pfinfile buffer created\n");

   if (setvbuf(pfoutfile, NULL, _IOLBF, 132) != 0)
      printf("pfoutfile buffer allocation error\n");
   else
      printf("pfoutfile buffer created\n");

   while(fscanf(pfinfile,"%c",&ichar) != EOF)
     fprintf(pfoutfile,"%c",ichar);

   fclose(pfinfile);
   fclose(pfoutfile);
}

