//
//  secs.cpp
//  C++ program illustrates the use of friend functions.
//  Program will collect a string of date and time
//  information from system. Time information will
//  be processed and converted into seconds.
//  Copyright (c) Chris H. Pappas and William H. Murray, 1998
//

#include <iostream.h>
#include <time.h>    // for tm & time_t structure
#include <string.h>  // for strtok function prototype
#include <stdlib.h>  // for atol function prototype

class time_class {
  long secs;
  friend char * present_time(time_class);  //friend
public:
  time_class(char *); 
};

time_class::time_class(char *tm)
{
  char *hours,*minutes,*seconds;

  // data returned in the following string format:
  // (day month date hours:minutes:seconds year)
  // Thus, need to skip over three tokens, ie.
  // skip day, month and date
  hours=strtok(tm," ");
  hours=strtok(0," ");
  hours=strtok(0," ");

  // collect time information from string
  hours=strtok(0,":");
  minutes=strtok(0,":");
  seconds=strtok(0," ");

  // convert data to long type and accumulate seconds.
  secs=atol(hours)*3600;
  secs+=atol(minutes)*60;
  secs+=atol(seconds);
}

char * present_time(time_class);  // prototype

main()
{
  // get the string of time & date information
  struct tm *ptr;
  time_t ltime;
  ltime=time(NULL);
  ptr=localtime(&ltime);

  time_class tz(asctime(ptr));

  cout << "The date/time string information: " 
       << asctime(ptr) << endl;
  cout << "The time converted to seconds: " 
       << present_time(tz) << endl;
  return (0);
}

char * present_time(time_class tz)
{
  char *ctbuf;
  ctbuf=new char[40];
  long int seconds_total;

  seconds_total=tz.secs;
  ltoa(seconds_total,ctbuf,10);
  return (ctbuf);
}

