//
//  filbuf.cpp
//  C++ program demonstrating how to use filebuf class.
//  Copyright (c) Chris H. Pappas and William H. Murray, 1998
//
//  Valid member functions include:
//         filebuf::attach      filebuf::close
//         filebuf::fd          filebuf::~filebuf
//         filebuf::filebuf     filebuf::is_open
//         filebuf::open        filebuf::overflow
//         filebuf::seekoff     filebuf::setbuf
//         filebuf::sync        filebuf::underflow
//

#include <fstream.h>
#include <fcntl.h>
#include <process.h> // exit prototype

void main(void)
{
  char ch;
  int iLineCount=0;
  filebuf fbMyInputBuf, fbMyOutputBuf;

  fbMyInputBuf.open("c:\\filbuf.cpp",_O_WRONLY | _O_TEXT);
  if(fbMyInputBuf.is_open() == 0) {
    cerr << "Can't open input file";
    exit (1);
  }

  istream is(&fbMyInputBuf);

  fbMyOutputBuf.open("c:\\output.dat",_O_WRONLY | _O_TEXT);
  if(fbMyOutputBuf.is_open() == 0) {
    cerr << "Can't open output file";
    exit (2);
  }

  ostream os(&fbMyOutputBuf);

  while(is) {
    is.get(ch);
    os.put(ch);
    iLineCount += (ch == '\n');
  }

  fbMyInputBuf.close();
  fbMyOutputBuf.close();

  cout << "You had " << iLineCount << " lines in your file";
}

