/*
*  swp.c
*  Simple Windows Program
*  Copyright (c) William H. Murray and Chris H. Pappas, 1998
*/

#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);

char szProgName[]="ProgName";

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPreInst,
                   LPSTR lpszCmdLine,int nCmdShow)
{
  HWND hWnd;
  MSG  lpMsg;
  WNDCLASS wcApp;
  
  wcApp.lpszClassName=szProgName;
  wcApp.hInstance    =hInst;
  wcApp.lpfnWndProc  =WndProc;
  wcApp.hCursor      =LoadCursor(NULL,IDC_ARROW);
  wcApp.hIcon        =0;
  wcApp.lpszMenuName =0;
  wcApp.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
  wcApp.style        =CS_HREDRAW|CS_VREDRAW;
  wcApp.cbClsExtra   =0;
  wcApp.cbWndExtra   =0;
  if (!RegisterClass (&wcApp))
    return 0;
  
  hWnd=CreateWindow(szProgName,"Simple Windows Program",
                    WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                    CW_USEDEFAULT,CW_USEDEFAULT,
                    CW_USEDEFAULT,(HWND)NULL,(HMENU)NULL,
                    hInst,(LPSTR)NULL);
  ShowWindow(hWnd,nCmdShow);
  UpdateWindow(hWnd);
  while (GetMessage(&lpMsg,0,0,0)) {
    TranslateMessage(&lpMsg);
    DispatchMessage(&lpMsg);
  }
  return(lpMsg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT messg,
                         WPARAM wParam,LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT ps;
 
  switch (messg)
  {
    case WM_PAINT:
      hdc=BeginPaint(hWnd,&ps);

      MoveToEx(hdc,0,0,NULL);
      LineTo(hdc,639,429);
      MoveToEx(hdc,300,0,NULL);
      LineTo(hdc,50,300);

      TextOut(hdc,120,30,"<- a few lines ->",17);

      ValidateRect(hWnd,NULL);
      EndPaint(hWnd,&ps);
      break;
    case WM_DESTROY:
      PostQuitMessage(0);
      break;
    default:
      return(DefWindowProc(hWnd,messg,wParam,lParam));
      break;
  }
  return(0);
}
