// GraphView.cpp : implementation of the CGraphView class
//

#include "stdafx.h"
#include "Graph.h"

#include "GraphDoc.h"
#include "GraphView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CGraphView

IMPLEMENT_DYNCREATE(CGraphView, CView)

BEGIN_MESSAGE_MAP(CGraphView, CView)
	//{{AFX_MSG_MAP(CGraphView)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphView construction/destruction

CGraphView::CGraphView()
{
	// TODO: add construction code here

}

CGraphView::~CGraphView()
{
}

BOOL CGraphView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGraphView drawing

void CGraphView::OnDraw(CDC* pDC)
{
	CGraphDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGraphView diagnostics

#ifdef _DEBUG
void CGraphView::AssertValid() const
{
	CView::AssertValid();
}

void CGraphView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGraphDoc* CGraphView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGraphDoc)));
	return (CGraphDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGraphView message handlers

void CGraphView::OnPaint() 
{
  static DWORD dwColor[9]={RGB(0,0,0),         //black
                           RGB(255,0,0),       //red
                           RGB(0,255,0),       //green
                           RGB(0,0,255),       //blue
                           RGB(255,255,0),     //yellow
                           RGB(255,0,255),     //magenta
                           RGB(0,255,255),     //cyan
                           RGB(127,127,127),   //gray
                           RGB(255,255,255)};  //white

  POINT polylpts[4],polygpts[5];
  int xcoord;

  CBrush newbrush;
  CBrush* oldbrush;
  CPen newpen;
  CPen* oldpen;  
  
  CPaintDC dc(this); // device context for painting        
 
  // draws and fills a red ellipse
  newpen.CreatePen(PS_SOLID,1,dwColor[1]);
  oldpen=dc.SelectObject(&newpen);
  newbrush.CreateSolidBrush(dwColor[1]);
  oldbrush=dc.SelectObject(&newbrush);
  dc.Ellipse(275,300,200,250);
  dc.TextOut(220,265,"ellipse",7); 
  dc.SelectObject(oldbrush);
  newbrush.DeleteObject( );
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws and fills a blue circle with ellipse function
  newpen.CreatePen(PS_SOLID,1,dwColor[3]);
  oldpen=dc.SelectObject(&newpen);
  newbrush.CreateSolidBrush(dwColor[3]);
  oldbrush=dc.SelectObject(&newbrush);
  dc.Ellipse(375,75,525,225);
  dc.TextOut(435,190,"circle",6);    
  dc.SelectObject(oldbrush);
  newbrush.DeleteObject( );
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws several green pixels
  for(xcoord=400;xcoord<450;xcoord+=5)
    dc.SetPixel(xcoord,350,0L);
  dc.TextOut(460,345,"<- pixels",9);

  // draws a wide black diagonal line
  newpen.CreatePen(PS_SOLID,6,dwColor[0]);
  oldpen=dc.SelectObject(&newpen);
  dc.MoveTo(20,20);
  dc.LineTo(100,100);
  dc.TextOut(60,20,"<- diagonal line",16);  
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws a blue arc
  newpen.CreatePen(PS_DASH,1,dwColor[3]);
  oldpen=dc.SelectObject(&newpen);
  dc.Arc(25,125,175,225,175,225,100,125);
  dc.TextOut(50,150,"small arc ->",12);   
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws a wide green chord
  newpen.CreatePen(PS_SOLID,8,dwColor[2]);
  oldpen=dc.SelectObject(&newpen);
  dc.Chord(125,125,275,225,275,225,200,125);
  dc.TextOut(280,150,"<- chord",8);
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws a black pie slice and fills with green
  newpen.CreatePen(PS_SOLID,1,dwColor[0]);
  oldpen=dc.SelectObject(&newpen);
  newbrush.CreateSolidBrush(dwColor[2]);
  oldbrush=dc.SelectObject(&newbrush);
  dc.Pie(200,0,300,100,200,50,250,100);
  dc.TextOut(260,80,"<- pie wedge",12);
  dc.SelectObject(oldbrush);
  newbrush.DeleteObject( );
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws a black rectangle and fills with gray
  newbrush.CreateSolidBrush(dwColor[7]);
  oldbrush=dc.SelectObject(&newbrush);
  dc.Rectangle(25,300,150,375);
  dc.TextOut(50,325,"rectangle",9);
  dc.SelectObject(oldbrush);
  newbrush.DeleteObject( );
  
  // draws a black rounded rectangle and fills with blue
  newbrush.CreateHatchBrush(HS_CROSS,dwColor[3]);
  oldbrush=dc.SelectObject(&newbrush);
  dc.RoundRect(350,250,400,290,20,20);
  dc.TextOut(410,270,"<--rounded rectangle",20);
  dc.SelectObject(oldbrush);
  newbrush.DeleteObject( );

  // draws several wide magenta lines with polyline
  newpen.CreatePen(PS_SOLID,3,dwColor[5]);
  oldpen=dc.SelectObject(&newpen);
  polylpts[0].x=10;
  polylpts[0].y=30;
  polylpts[1].x=10;
  polylpts[1].y=100;
  polylpts[2].x=50;
  polylpts[2].y=100;
  polylpts[3].x=10;
  polylpts[3].y=30;
  dc.Polyline(polylpts,4);
  dc.TextOut(10,110,"polyline",8);  
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );

  // draws a wide cyan polygon and
  // fills with diagonal yellow
  newpen.CreatePen(PS_SOLID,4,dwColor[6]);
  oldpen=dc.SelectObject(&newpen);
  newbrush.CreateHatchBrush(HS_FDIAGONAL,dwColor[4]);
  oldbrush=dc.SelectObject(&newbrush);
  polygpts[0].x=40;
  polygpts[0].y=200;
  polygpts[1].x=100;
  polygpts[1].y=270;
  polygpts[2].x=80;
  polygpts[2].y=290;
  polygpts[3].x=20;
  polygpts[3].y=220;
  polygpts[4].x=40;
  polygpts[4].y=200;
  dc.Polygon(polygpts,5);
  dc.TextOut(80,230,"<- polygon",10);
  dc.SelectObject(oldbrush);
  newbrush.DeleteObject( );
  dc.SelectObject(oldpen);
  newpen.DeleteObject( );
	
	// Do not call CView::OnPaint() for painting messages
}
