// TDCtrlCtl.cpp : Implementation of the CTDCtrlCtrl ActiveX Control class.

#include "stdafx.h"
#include "TDCtrl.h"
#include "TDCtrlCtl.h"
#include "TDCtrlPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CTDCtrlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CTDCtrlCtrl, COleControl)
	//{{AFX_MSG_MAP(CTDCtrlCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CTDCtrlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CTDCtrlCtrl)
	DISP_PROPERTY(CTDCtrlCtrl, "HitTDCtrl", m_hitTDCtrl, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CTDCtrlCtrl, "TDShape", m_tDShape, OnTDShapeChanged, VT_BOOL)
	DISP_STOCKPROP_BACKCOLOR()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CTDCtrlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CTDCtrlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CTDCtrlCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CTDCtrlCtrl, 1)
	PROPPAGEID(CTDCtrlPropPage::guid)
END_PROPPAGEIDS(CTDCtrlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CTDCtrlCtrl, "TDCTRL.TDCtrlCtrl.1",
	0xc0377506, 0xb276, 0x11d1, 0xba, 0xe9, 0, 0xa0, 0xc9, 0x8c, 0xc4, 0x6e)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CTDCtrlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DTDCtrl =
		{ 0xc0377504, 0xb276, 0x11d1, { 0xba, 0xe9, 0, 0xa0, 0xc9, 0x8c, 0xc4, 0x6e } };
const IID BASED_CODE IID_DTDCtrlEvents =
		{ 0xc0377505, 0xb276, 0x11d1, { 0xba, 0xe9, 0, 0xa0, 0xc9, 0x8c, 0xc4, 0x6e } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwTDCtrlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CTDCtrlCtrl, IDS_TDCTRL, _dwTDCtrlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::CTDCtrlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CTDCtrlCtrl

BOOL CTDCtrlCtrl::CTDCtrlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_TDCTRL,
			IDB_TDCTRL,
			afxRegApartmentThreading,
			_dwTDCtrlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::CTDCtrlCtrl - Constructor

CTDCtrlCtrl::CTDCtrlCtrl()
{
	InitializeIIDs(&IID_DTDCtrl, &IID_DTDCtrlEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::~CTDCtrlCtrl - Destructor

CTDCtrlCtrl::~CTDCtrlCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::OnDraw - Drawing function

void CTDCtrlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
  CBrush* pOldBrush;
  CBrush NewBrush;  
  CPen* pOldPen;
  CPen NewPen;
   
  pdc->FillRect(rcBounds,CBrush::FromHandle((HBRUSH) \
                GetStockObject(WHITE_BRUSH)));
  
  NewPen.CreatePen(PS_SOLID,3,RGB(0,0,0));
  pOldPen=(CPen*)pdc->SelectObject(&NewPen);
  
  // Create a yellow brush 
  NewBrush.CreateSolidBrush(RGB(255,255,0));
  pOldBrush=(CBrush*)pdc->SelectObject(&NewBrush);

  // Draw and fill the rectangle
  pdc->Rectangle(rcBounds);

  pdc->SelectObject(pOldPen);
  pdc->SelectObject(pOldBrush);
}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::DoPropExchange - Persistence support

void CTDCtrlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
    // Use a light-gray color to show a hit
    PX_Long(pPX,_T("HitTDCtrl"), (long &)m_hitTDCtrl,
            RGB(200, 200, 200));

}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::OnResetState - Reset control to default state

void CTDCtrlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl::AboutBox - Display an "About" box to the user

void CTDCtrlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_TDCTRL);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CTDCtrlCtrl message handlers

void CTDCtrlCtrl::OnTDShapeChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CTDCtrlCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	CDC* pdc;

    //Blink a color change for control

    pdc = GetDC( );
    HitTDCtrl(pdc);
    ReleaseDC(pdc);

	
	COleControl::OnLButtonDown(nFlags, point);
}

void CTDCtrlCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

    InvalidateControl( );

	COleControl::OnLButtonUp(nFlags, point);
}

void CTDCtrlCtrl::HitTDCtrl(CDC* pdc)
{

  CBrush* pOldBrush;
  CBrush hitBrush(TranslateColor(m_hitTDCtrl));
  CRect rc;
  TEXTMETRIC tm;
  struct tm *date_time;
  time_t timer;

  // Background mode to transparent
  pdc->SetBkMode(TRANSPARENT);

  GetClientRect(rc);

  pOldBrush=pdc->SelectObject(&hitBrush);

  // Draw and fill the rectangle 
  pdc->Rectangle(rc);

  // Get time and date
  time(&timer);
  date_time=localtime(&timer);
  const CString& strtime = asctime(date_time);

  // Get Font information then print
  pdc->GetTextMetrics(&tm);
  pdc->SetTextAlign(TA_CENTER | TA_TOP);
  pdc->ExtTextOut((rc.left + rc.right) / 2,
                  (rc.top + rc.bottom - tm.tmHeight) /2,
                  ETO_CLIPPED, rc, strtime,
                  strtime.GetLength( ) - 1, NULL);
  pdc->SelectObject(pOldBrush);
}
